//  *********************************************************************************************
//  *                                                                                           *
//  *                                  SpikenzieLabs.com                                        *
//  *                                                                                           *
//  *                                SPLixel LED Controler                                      *
//  *                                                                                           *
//  *                                                                                           *
//  *********************************************************************************************
//
// BY: MARK DEMERS 
// March 2014
// VERSION 0.1
//
// Changes:
//



  #include "Arduino.h"
  #include "SPLixel.h"
  #include "HardwareSerial.h"

extern "C" {
#include <string.h>
#include <stdlib.h>
}

uint8_t _nul_data = 0;

SPLixel::SPLixel(uint8_t MAXLEDS)
{
  _MAXLEDS = MAXLEDS;
}

void SPLixel::begin()
{

  Serial.begin(57600);

  Serial_TX_WS(0x42,_MAXLEDS,0,0);

}

void SPLixel::Serial_TX_WS(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
     uint8_t _WSCOLTX[4] = {LED_data,R_data,G_data,B_data};  
 
	 Serial.write(_WSCOLTX, 4);    
}

void SPLixel::draw(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
    uint8_t _WSCOLTX[4] = {LED_data,R_data,G_data,B_data};  
    Serial.write(_WSCOLTX, 4); 
}

void SPLixel::rainbow(uint8_t LED_data, uint8_t R_data)
{
//	uint8_t _TX_data = 0;
    uint8_t _WSCOLTX[4] = {0x47,LED_data,R_data,_nul_data};  
    Serial.write(_WSCOLTX, 4); 
}

void SPLixel::rainbow(uint8_t LED_data, uint8_t R_data, uint8_t G_data)
{
    uint8_t _WSCOLTX[4] = {0x47,LED_data,R_data,G_data};  
    Serial.write(_WSCOLTX, 4); 
}

void SPLixel::dimmer(uint8_t LED_data)
{
//	uint8_t _TX_data = 0;
    uint8_t _WSCOLTX[4] = {0x4B,LED_data,_nul_data,_nul_data};  
    Serial.write(_WSCOLTX, 4); 
}

void SPLixel::buffer(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
    uint8_t _WSCOLTX[4] = {LED_data+128,R_data,G_data,B_data};  
    Serial.write(_WSCOLTX, 4); 
}

void SPLixel::all(uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
	Serial_TX_WS(0x41,R_data,G_data,B_data);
}

void SPLixel::shiftup(uint8_t SPEED_data)
{
	Serial_TX_WS(0x4E,SPEED_data,_nul_data,_nul_data);
}

void SPLixel::shiftup(uint8_t SPEED_data, uint8_t COUNT_data)
{
	Serial_TX_WS(0x52, COUNT_data, SPEED_data,_nul_data);
}

void SPLixel::shiftdown(uint8_t SPEED_data)
{
	Serial_TX_WS(0x44,SPEED_data,_nul_data,_nul_data);
}

void SPLixel::shiftdown(uint8_t SPEED_data,  uint8_t COUNT_data)
{
	Serial_TX_WS(0x53, COUNT_data, SPEED_data,_nul_data);
}

void SPLixel::shiftin(uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
	Serial_TX_WS(0x51,R_data,G_data,B_data);
}

void SPLixel::blink(uint8_t SPEED_data)
{
	Serial_TX_WS(0x45,SPEED_data,_nul_data,_nul_data);
}

void SPLixel::shifteight(uint8_t refresh_data)
{
	Serial_TX_WS(0x50,refresh_data,_nul_data,_nul_data);
}

void SPLixel::refresh()
{
//	uint8_t _TX_data = 0;
	Serial_TX_WS(0x4F,_nul_data,_nul_data,_nul_data);
}


void SPLixel::larson(uint8_t R_data, uint8_t G_data, uint8_t B_data, uint8_t SP_data)
{
	Serial_TX_WS(0x4C,R_data,G_data,B_data);		    // Color of larson
    Serial_TX_WS(0x4D,SP_data,_nul_data,_nul_data);		// Speed of larson
}

void SPLixel::barcolor(uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
	Serial_TX_WS(0x48,R_data,G_data,B_data);		// Color of bar
}

void SPLixel::bartopcolor(uint8_t R_data, uint8_t G_data, uint8_t B_data)
{
	Serial_TX_WS(0x49,R_data,G_data,B_data);		// Color of bar top pixel
}

void SPLixel::baraction(uint8_t H_data, uint8_t SU_data, uint8_t SD_data)
{
	Serial_TX_WS(0x4A,H_data,SU_data,SD_data);		// Fill bar
}

void SPLixel::clear()
{
    uint8_t _TX_data = 0;
	Serial_TX_WS(0x41,_nul_data,_nul_data,_nul_data);
}

uint8_t SPLixel::LEDCOUNT()
{
	return _MAXLEDS;
}


