//  *********************************************************************************************
//  *                                                                                           *
//  *                                  SpikenzieLabs.com                                        *
//  *                                                                                           *
//  *                                SPLixel LED Controler                                      *
//  *                                                                                           *
//  *                                                                                           *
//  *********************************************************************************************
//
// BY: MARK DEMERS 
// March 2014
// VERSION 0.1
//
// Changes:
// Date
// 1. 
// 2. 

#ifndef SPLixel_h
#define SPLixel_h

#include "Arduino.h"
#include <inttypes.h>


#define  POWERUP 4                   //   0   0   1   0   0 

class SPLixel
{
  public:
    SPLixel(uint8_t MAXLEDS);
    void all(uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void draw(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void clear();
    void begin();
    void larson(uint8_t R_data, uint8_t G_data, uint8_t B_data, uint8_t SP_data);
    void buffer(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void barcolor(uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void bartopcolor(uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void baraction(uint8_t H_data, uint8_t SU_data, uint8_t SD_data);
    void refresh();
    void rainbow(uint8_t LED_data, uint8_t R_data);
    void rainbow(uint8_t LED_data, uint8_t R_data, uint8_t G_data);
    void dimmer(uint8_t LED_data);
    void blink(uint8_t SPEED_data);
    void shiftup(uint8_t SPEED_data);
    void shiftdown(uint8_t SPEED_data); 
    void shiftup(uint8_t SPEED_data, uint8_t COUNT_data);
    void shiftdown(uint8_t SPEED_data, uint8_t COUNT_data);
    void shiftin(uint8_t R_data, uint8_t G_data, uint8_t B_data);
    void shifteight(uint8_t refresh_data);
    uint8_t LEDCOUNT();
  private:
  	void Serial_TX_WS(uint8_t LED_data, uint8_t R_data, uint8_t G_data, uint8_t B_data);
  	uint8_t _MAXLEDS;
  	uint8_t _nul_data;
  //	uint8_t _WSCOLTX[4];
};

#endif

